﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MosaicGen
{
    /// <summary>
    /// Interaction logic for AvailableDisband.xaml
    /// </summary>
    public partial class AvailableDisband : Window
    {
        MosaicWorker msW;
        public AvailableDisband( MosaicWorker msW)
        {
            InitializeComponent();
            this.msW = msW;
            ListboxLoad();
          
        }

        private void ListboxLoad() {
            AvailableListbox.Items.Clear();
            DisbandListBox.Items.Clear();  
            foreach (Msquare sq in msW.Available)
            {

                Image i = new Image();
                i.Source = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(sq.Picture.GetHbitmap(), IntPtr.Zero, System.Windows.Int32Rect.Empty, System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
                AvailableListbox.Items.Add(i);
            }
            foreach (Msquare sq in msW.Disband)
            {

                Image i = new Image();
                i.Source = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(sq.Picture.GetHbitmap(), IntPtr.Zero, System.Windows.Int32Rect.Empty, System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
                DisbandListBox.Items.Add(i);
            }
        }

        private void toAvailable_Click(object sender, RoutedEventArgs e)
        {
            KeepSelected();
            int selItem = DisbandListBox.SelectedIndex;
            if (selItem == -1)
            {
                MessageBox.Show("!!!");
            }
            else
            {
                msW.MoveToAvailable(selItem);
                ListboxLoad();
            }
           
        }

        private void toDisband_Click(object sender, RoutedEventArgs e)
        {
            KeepSelected();
            int selItem = AvailableListbox.SelectedIndex;
            if (selItem == -1)
            {
                MessageBox.Show("!!!");
            }
            else
            {
                msW.MoveToDisband(selItem);
                ListboxLoad();
            }
        }

        private void toDisbandAll_Click(object sender, RoutedEventArgs e)
        {
          
           for( int i = msW.Available.Count();i>0;i--) {
               msW.MoveToDisband(0);
               ListboxLoad();
           }
        }

        private void toAvailableAll_Click(object sender, RoutedEventArgs e)
        {
            for (int i = msW.Disband.Count(); i > 0; i--)
            {
                msW.MoveToAvailable(0);
                ListboxLoad();
            }

        }

        private void KeepSelected()
        {
            if (AvailableListbox.SelectedIndex == -1)
            {
                if (AvailableListbox.Items.Count > 0)
                {
                    AvailableListbox.SelectedIndex = 0;
                }
            }
            if (DisbandListBox.SelectedIndex == -1)
            {
                if (DisbandListBox.Items.Count > 0)
                {
                    DisbandListBox.SelectedIndex = 0;
                }
            }
        }

        private void Window_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            AvailableListbox.Height = this.Height - 91;
            DisbandListBox.Height = this.Height - 91;
        }

        private void MyCommandClose(object sender, ExecutedRoutedEventArgs e)
        {
            this.Close();
        }

        private void MyCommandHelp(object sender, ExecutedRoutedEventArgs e)
        {
            HelpWindow h = new HelpWindow
            ("Move pictures from/to available/diband and by this, you choosed if you want used them now or not. Tjis will be saved just until you close this program. no longer./n Shorcuts:/n F1 - help, Ctrl+Q close/quit");
            h.ShowDialog();
        }
      
    }
}
