﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Drawing;
using System.Windows.Media.Imaging;
using System.Windows.Media;
using Microsoft.Win32;
using System.Windows;

namespace MosaicGen
{
    /// <summary>
    /// třída starající se o načtení předpřipravených částí mozaiky
    /// </summary>
    class MSquareLoadSaveSample
    {

        private List<Msquare> squares = new List<Msquare>();
      

        public MSquareLoadSaveSample()
        {
            getSamples();
        }
        /// <summary>
        /// vrátí všechny předpřipravené části mozaiky v listu. jen ty co jsou plně v pořádku.
        /// Pokud už je nějaké nastavení disband allowed tak se všechny nové privky přesunou automaticky do disband,
        /// pokud není nic v disband tak do allow
        /// </summary>
        /// <returns></returns>
        public List<Msquare> getSamples()
        {
            squares.Clear();
            LoadSamples();
            return squares;
        }
        
        private void LoadSamples()
        {
            string[] samples = Directory.GetFiles(@"samples\", "*.bmp");
            foreach (string path in samples)
            {
                try
                {
                    string txtPath = Path.ChangeExtension(path, ".txt");
                    Bitmap picture = new Bitmap(path);
                    string [] parseText = File.ReadAllText(txtPath).Split(';');
                    Msquare loadedSquare = new Msquare(picture, parseText [0], Convert.ToInt32(parseText [1]), Convert.ToInt32(parseText [2]), Convert.ToInt32(parseText [3]), Convert.ToInt32(parseText [4]));
                    squares.Add(loadedSquare);
                }
                catch (Exception)
                {
                }
            }
        }

        public override string ToString()
        {
            string s ="";
            foreach(Msquare m in squares) {
            s+= "-"+m.ToString();
            }
            return s;
            //return squares.Count.ToString();
        }

        
        public bool CanSave(Msquare msQ)
        {
            foreach (Msquare m in squares)
            {
                if (m.Name.Equals(msQ.Name))
                {
                    return false;
                }
            }
            if (msQ.Picture == null) return false;
            return true;
        }

        

       

    }
}
