﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MosaicGen
{
    class MosaicGenerator
    {
        private Random ran;
        bool edges;
        private Msquare [,] mosaic;
        private List<Msquare> availablesquare = new List<Msquare>();
        private List<Msquare> toGenerate = new List<Msquare>();

        public MosaicGenerator(Msquare [,] mosaic, List<Msquare> availablesquare, bool edges)
        {
            this.mosaic = new Msquare [mosaic.GetLength(0), mosaic.GetLength(1)];
            this.availablesquare = availablesquare;
            this.edges = edges;
            ran = new Random();
        }


        public Msquare [,] Generate(int type)
        {
            GenAlgorytm1();
            return mosaic;
        }

        private void GenAlgorytm1()
        {
          for (int i = 0; i < mosaic.GetLength(0);i++ )
            {
             for (int j = 0; j < mosaic.GetLength(1); j++)
                {
                    if (!Place(i,j))
                    {
                        mosaic [i, j] = new Msquare(new System.Drawing.Bitmap(64, 64), "null", 0, 0, 0, 0);
                    }
                }
            }
        }

        private bool Place(int x, int y)
        {
            toGenerate.Clear();
            foreach (Msquare s in availablesquare)
            {
                toGenerate.Add((Msquare)s.Clone());
            }
           
            int choose = (ran.Next() % toGenerate.Count());
            while (toGenerate.Count > 0)
            {
                Msquare choosed = toGenerate[choose];
                int rotate = ran.Next() % 4;
                choosed.Rotate(rotate);

                if (TryFit(x, y, choosed))
                {
                     mosaic [x, y] = choosed;
                    return true;
                }
                else 
                {
                    toGenerate.RemoveAt(choose);
                    if (toGenerate.Count() < 1)
                    {
                        break;
                    }
                    choose = (ran.Next() % toGenerate.Count());
                }
            }
           return false;
        }

        private bool TryFit(int x, int y, Msquare m)
        {
            bool fit;
            for (int i = 0; i < 4; i++)
            {
                fit = true;
                if (!edges)
                {
                    if (mosaic [(x - 1 + mosaic.GetLength(0)) % mosaic.GetLength(0), y] == null)
                    {
                        fit = fit && true;
                    }
                    else
                    {
                        fit = fit && m.LefttFit(mosaic [(x - 1 + mosaic.GetLength(0)) % mosaic.GetLength(0), y]);
                    }
                    if (mosaic [x, (y - 1 + mosaic.GetLength(1)) % mosaic.GetLength(1)] == null)
                    {
                        fit = fit && true;
                    }
                    else
                    {
                        fit = fit && m.UpFit(mosaic [x, (y - 1 + mosaic.GetLength(1)) % mosaic.GetLength(1)]);
                    }
                    if (mosaic [(x + 1 + mosaic.GetLength(0)) % mosaic.GetLength(0), y] == null)
                    {
                        fit = fit && true;
                    }
                    else
                    {
                        fit = fit && m.RightFit(mosaic [(x + 1 + mosaic.GetLength(0)) % mosaic.GetLength(0), y]);
                    }
                    if (mosaic [x, (y + 1 + mosaic.GetLength(1)) % mosaic.GetLength(1)] == null)
                    {
                        fit = fit && true;
                    }
                    else
                    {
                        fit = fit && m.DownFit(mosaic [x,  (y + 1 + mosaic.GetLength(1)) % mosaic.GetLength(1)]);
                    }
                }
                else
                {
                    if (x > 0)
                    {
                        if (mosaic [x - 1, y] == null)
                        {
                            fit = fit && true;
                        }
                        else
                        {
                            fit = fit && m.LefttFit(mosaic [x - 1, y]);
                        }
                    }
                    if (y > 0)
                    {
                        if (mosaic [x, y - 1] == null)
                        {
                            fit = fit && true;
                        }
                        else
                        {
                            fit = fit && m.UpFit(mosaic [x, y - 1]);
                        }

                    }
                    if (x < mosaic.GetLength(0) - 1)
                    {
                        if (mosaic [x + 1, y] == null)
                        {
                            fit = fit && true;
                        }
                        else
                        {
                            fit = fit && m.RightFit(mosaic [x + 1, y]);
                        }
                    }
                    if (y < mosaic.GetLength(1) - 1)
                    {
                        if (mosaic [x, y + 1] == null)
                        {
                            fit = fit && true;
                        }
                        else
                        {
                            fit = fit && m.DownFit(mosaic [x, y + 1]);
                        }
                    }
                }
                if (fit)
                {
                    return true;
                }
                else
                {
                    m.Rotate(1);
                }
            }
            return false;
        }

       
    }
}
