﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MosaicGen
{
    public class MosaicWorker
    {
        private MSquareLoadSaveSample loader = new MSquareLoadSaveSample();
        internal MSquareLoadSaveSample Loader
        {
            get { return loader; }
            
        }

       
        private Msquare [,] mosaic = new Msquare [10, 10]; //defaultní velikost
        private List<Msquare> squareType = new List<Msquare>();
        private List<Msquare> available = new List<Msquare>();
        private List<Msquare> disband = new List<Msquare>();

        public List<Msquare> Available
        {
            get { return available; }
        }
        public List<Msquare> Disband
        {
            get { return disband; }
        }
        internal List<Msquare> SquareType
        {
            get { return squareType; }
        }

        public Msquare this[int x,int y]{
           get
           {
              return mosaic [x, y];
           }
           set
           {
               mosaic [x, y] = value;
           }
        }


        public MosaicWorker()
        {
            LoadSquares();
        }
       
        public MosaicWorker(int width, int height)
        {
            Resize(width, height);
            LoadSquares();
        }

        public void Resize(int width, int height)
        {
            mosaic = new Msquare [width, height];
        }

        public void ReloadSquares()
        {
            LoadSquares();
        }
        
        private void LoadSquares()
        {
            bool isDismis = disband.Count > 0;
            squareType = loader.getSamples();
            foreach (Msquare mS in squareType)
            {
                if (!available.Contains(mS) && !disband.Contains(mS))
                {
                    if (isDismis)
                    {
                        disband.Add(mS);
                    }
                    else
                    {
                        available.Add(mS);
                    }
                }
            }
        }

        private void SetMosaic(int width, int height, int squarePos)
        {
            this[width,height] = squareType[squarePos];
        }

        public int GetRows() {
            return mosaic.GetLength(1);
        }
        public int GetColumns()
        {
            return mosaic.GetLength(0);
        }

        public void MoveToDisband(int position)
        {
            Msquare temp = available [position];
            available.RemoveAt(position);
            disband.Add(temp);
        }

        public void MoveToAvailable(int position)
        {
            Msquare temp = disband [position];
            disband.RemoveAt(position);
            available.Add(temp);
        }





    }
}
