﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MosaicGen
{
    /// <summary>
    /// Interaction logic for MyControl.xaml
    /// </summary>
    public partial class MyControl : UserControl
    {
        double number = 0;
        bool validate =true;
        public MyControl()
        {
            InitializeComponent();
            NumericTexbox.Text = number.ToString();
            Canvas.Background = new SolidColorBrush(Color.FromRgb(197, 185, 184));
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            number--;
            SetValue(number);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            number++;
            SetValue(number);
        }

        private void NumericTexbox_LostKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            NumericTexbox.Text = NumericTexbox.Text.Replace('.', ',');
            if (NumericTexbox.Text.Length == 0)
            {
                number = 0;
                NumericTexbox.Text = number.ToString();
                return;
            }
            double d;
            if (Double.TryParse(NumericTexbox.Text, out d))
            {
                number = d;
                NumericTexbox.Text = number.ToString();
            }
            else
            {
                ((TextBox)sender).Background = Brushes.LightPink;
                ((TextBox)sender).Focus();
                validate = false;
            }
        }

        private void NumericTexbox_TextChanged(object sender, TextChangedEventArgs e)
        {
            ((TextBox)sender).Background = Brushes.White;
            validate = true;
        }

        private void UserControl_MouseEnter(object sender, MouseEventArgs e)
        {
            Canvas.Background = new SolidColorBrush(Color.FromRgb(133,136,135));
        }

        private void Canvas_MouseLeave(object sender, MouseEventArgs e)
        {
            Canvas.Background = new SolidColorBrush(Color.FromRgb(197, 185, 184));
        }

        public int GetValue()
        {
            return Convert.ToInt32(number);
        }

        public bool IsValidate()
        {
            return validate;
        }

        public void SetValue(Double number)
        {
            this.number = number;
            NumericTexbox.Text = number.ToString();
        }
    }
}
