﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace MosaicGen
{
    /// <summary>
    /// Interaction logic for SizeChanged.xaml
    /// </summary>
    public partial class SizeChanged : Window
    {
        MosaicWorker msW;

        public SizeChanged()
        {
            InitializeComponent();
        }

        public SizeChanged( MosaicWorker msW) {
            InitializeComponent();
            this.msW = msW;
            
        }

        public SizeChanged(MosaicWorker msW, int rows, int columns) 
        {
            InitializeComponent();
            this.msW = msW;
            NumericRows.SetValue(rows);
            NumericColumns.SetValue(columns);
        }
        private void MyCommandClose(object sender, ExecutedRoutedEventArgs e)
        {
            this.Close();
        }

        private void MyCommandSave(object sender, ExecutedRoutedEventArgs e)
        {
            if (NumericRows.IsValidate() && NumericColumns.IsValidate())
            {
                if (NumericRows.GetValue() < 1 || NumericColumns.GetValue() < 1)
                {
                    MessageBox.Show("Number greater than zero", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning);
                }
                else
                {
                    int rows = NumericRows.GetValue();
                    int columns = NumericColumns.GetValue();
                    msW.Resize(columns, rows);
                    this.Close();
                }
            }
            else
            {
                MessageBox.Show("Need a number", "Warning", MessageBoxButton.OK, MessageBoxImage.Warning);
            }
        }

        private void MyCommandHelp(object sender, ExecutedRoutedEventArgs e)
        {
            HelpWindow h = new HelpWindow
            ("Just choose size of your 'workdesk' and click apply./n Shorcuts:/n F1 - help, Ctrl+S save and close, Ctrl + Q close/quit");
            h.ShowDialog();
        }
    }
}
